void bullet_touch(entity_t *self, entity_t *other) {
	if (self == NULL || other == NULL) return;
	if ((other->flags & FLAG_DEAD) == FLAG_DEAD) return;
	if ((other != self->owner) && (other->class != CLASS_BULLET)) {
		damage(other, self, self->owner);
		if (!(self->flags & FLAG_BULLETPIERCE)) kill(self);		// Remove the bullet
	}
};


void render_bullet(struct entity_t *self) {
	if (self == NULL) return;
	int x = (self->x >> 8) - screen_x;
	int y = (self->y >> 8) - screen_y;
	
	switch (self->weapon) {
		case 0:	// Shotgun
			Sprite8(x, y, 8, sprites_bullet[0], sprtbufl, A_OR);
			Sprite8(x, y, 8, sprites_bullet[1], sprtbufd, A_OR);
			break;
		case 1:	// Machine-gun
		case 2:	// Spread
			Sprite8(x, y, 8, sprites_bullet[4], sprtbufl, A_OR);
			Sprite8(x, y, 8, sprites_bullet[5], sprtbufd, A_OR);
			break;
	};			
};

entity_t *spawn_bullet(entity_t *self, signed long xo, signed long yo,
                       signed long dx, signed long dy)
{
	if (self == NULL) return NULL;
	
	entity_t	*bullet = spawn();
	if (bullet == NULL) return NULL;
	bullet->class = CLASS_BULLET;
	bullet->width = 3; bullet->height = 3;
	bullet->x = self->x + xo + (3<<8);
	bullet->y = self->y + yo + (3<<8);
	bullet->dx = dx; bullet->dy = dy;
	bullet->render = (func_t *)render_bullet;
	bullet->flags = FLAG_NOGRAVITY | (self->flags & FLAG_FACERIGHT) | FLAG_NOFRICTION;
	bullet->owner = self;
	bullet->weapon = self->weapon;
	bullet->touch = (touch_t *)bullet_touch;
	bullet->death = (func_t *)sub_remove;
	bullet->next_think = time + 30;
	bullet->think = (func_t *)sub_remove;
	return bullet;
};
