void render_grunt(struct entity_t *self) {
	draw_player(self);
};


void grunt_think(struct entity_t *self) {
	if (self == NULL) return;
	if ((rand() % 60 == time % 30) && (self->attack_time <= time)) {
		self->attack_time = time + 15;
		spawn_bullet(self, ((self->flags & FLAG_FACERIGHT) ? (8 << 8) : -(8 << 8)), 8 << 8,
			(self->flags & FLAG_FACERIGHT) ? 680 : -680, 0);
	}
	self->dx = (self->flags & FLAG_FACERIGHT) ? 380 : -380;
	if ((rand() % 50 == 2) && (self->flags & FLAG_ONGROUND)) {
		self->dy -= 1400;
		self->flags &= ~FLAG_ONGROUND;
	};
	self->next_think = time + 1;
};

void grunt_touch(struct entity_t *self, struct entity_t *other) {
	if (other->class != CLASS_PLAYER) return;
	if (self->attack_time <= time) {
		self->attack_time = time + 30;
		damage(other, self, self);
	};
};

void grunt_collide(struct entity_t *self) {
	if ((self->colflags & BLOCKED_GROUND)) {
		self->y = (self->y >> 11) << 11;
		self->dy = 0;
		self->flags |= FLAG_ONGROUND;
	} else {
		self->flags &= ~FLAG_ONGROUND;
	};
	if ((self->colflags & BLOCKED_LHS) == BLOCKED_LHS) {
		self->x = self->oldx;
		self->dx = 0;
		return;
	};
	if ((self->colflags & BLOCKED_RHS) == BLOCKED_RHS) {
		self->x = self->oldx;
		self->dx = 0;
		return;
	};
};

void grunt_death(entity_t *self) {
	// Send him upwards and back:
	self->dy = -512;
	self->dx = (self->flags & FLAG_FACERIGHT) ? -1412 : 1412;
	// Enable dead and liedown flag, but disable onground flag::
	self->flags |= FLAG_LIEDOWN | FLAG_DEAD;
	self->flags &= ~FLAG_ONGROUND;
	
	self->death = NULL;
	self->think = (func_t *)sub_remove;
	self->next_think = time + 30;
};

entity_t *spawn_grunt() {
	entity_t *curr = spawn();
	if (curr != NULL) {
		curr->width = 8; curr->height = 16;
		{
			curr->x = ((screen_x + screen_w - 8) << 8);
			curr->dx = -480;
			curr->flags &= ~FLAG_FACERIGHT;
		};
		curr->y = player->y - 768;
		curr->class = CLASS_GRUNT;
		curr->dy = 0;
		curr->render = (func_t *)render_grunt;
		curr->think = (func_t *)grunt_think;
		curr->death = (func_t *)grunt_death;
		curr->touch = (touch_t *)grunt_touch;
		curr->collide = (func_t *)grunt_collide;
		curr->next_think = time + 1;
		// Grunt's health is 32, which is the same amount of damage a player's bullet does.
		curr->health = curr->max_health = 32;
	};
	return curr;
};

